# Changelog

<!--
### ✨ Feature
### 🤏 Minor change
### 🎨 Interface
### 🐛 Bugfix
### 🔒 Security
### 🚀‍️ CI / CD
### 🔨 Internal / Developers
### 📚 Documentation

**💥 Breaking:**
**⚠️ Deprecation:**

### 🔨 Internal / Developers
- No modifications / Keep major and minors versions in sync with all parts of the project
-->


## 4.1.0 (Upcoming)

### ✨ Feature
- Add features related to corrige (commentary, commit specific link / update, delete link)

### 🎨 Interface
- Ask for confirmation before creating an exercise that already exists


## 4.0.0 (2024-04-19)

### ✨ Feature
- Add features related to corrige (commentary, commit specific link / update, delete link)

### 🔨 Internal / Developers
- Migration to GitBreaker library for all Gitlab API calls
- SonarQube integration
- Multi-process start is disabled where it is not in a production environment

### 🐛 Bugfix
- Fix no response when Authorization header is missing
- Fix get assignment by url with assignment containing spaces

### 📚 Documentation
- Corrige routes documentation


## 3.5.3 (2024-02-26)

### 🐛 Bugfix
- Change exercise visibility not assignment visibility


## 3.5.2 (2024-02-26)

### 🐛 Bugfix
- Add missing code to move correction from private to internal repository


## 3.5.1 (2024-02-22)

### 🐛 Bugfix
- Corrections: Take the exercise last commit instead of the assignment last commit


## 3.5.0 (2024-02-21)

### ✨ Feature
- Link a commit of an exercise as a corrige of an assignment


## 3.4.2 (2024-01-23)

### 📚 Documentation
- Wiki: add tutorial about adding a new route to the API


## 3.4.1 (2024-01-25)

### 🐛 Bugfix
- Fix assignment gitlab CI/CD pipeline: fix the name of the dind service


## 3.4.0 (2024-01-23)

### ✨ Feature
- Limit of 2 exercises by user


## 3.3.0 (2024-01-18)

### ✨ Feature
- **CLI**: Show an information message when a new version of the CLI is available (and not required)

### 🐛 Bugfix
- Fix an error when providing template for assignment creation


## 3.2.0 (2023-12-19)

### 🤏 Minor change
- **Exercices**: Set names of students in exercise name in alphabetical order


## 3.1.0 (2023-12-06)

### 🔨 Internal / Developers
- **Typescript**: Add linter (ESLint)

### 📚 Documentation
- **API**: Routes documentation with Swagger


## 3.0.0 (2023-11-03)

### ✨ Feature
- Login to Dojo app via Gitlab OAuth
- User access type management
    - **student**: default access type for new users
    - **teachingStaff**: student access + possibility of creating assignment
    - **admin**: teachingStaff access + access to user access management


## 2.2.0 (2023-10-16)

### ✨ Feature
- `results.json` file is now optional (if the teaching staff don't want to provide test details)
    - The exercise will be considered as valid if the container exit code is 0
    - The `results.json` file will be construct / completed with the container exit code
    - The `volume` argument of `dojo_assignment.json` is now optional (if the teaching staff don't want to provide `results.json` file or other files)
- Client version detection (if the client version is too old, the API will return an error)

### 🔨 Internal / Developers
- Enhancement in pipelines by splitting them into several files


## 2.1.0 (2023-09-29)

### ✨ Feature
- Added pipeline badge to exercises

### 🎨 Interface
- **💥 Breaking:** Renamed `dojo.enonce` (or `dojo.assignment`) file to `dojo_assignment.json`

### 🔨 Internal / Developers
- Deploy Wiki on Gitlab (on push to `main`) from files of `Wiki` folder
- Migration from .env files stored in Gitlab Secure Files to usage of `dotenv-vault` (locally)

### 📚 Documentation
- Added Wiki base


## 2.0.0 (2023-09-15)

### ✨ Feature
- Added license: AGPLv3

### 🎨 Interface
- **💥 Breaking:** Renamed `enonce` to `assignment`
- **💥 Breaking:** Renamed `exercice` to `exercise`

### 🔨 Internal / Developers
- Auto release by pipeline
    - For vX.Y.Z branch create release and tag with `-dev` suffix
    - For main branch create definitive release and remove `-dev` releases


## 1.0.1 (2023-08-12)

### ✨ Feature
- 🎉 Initial release of the project